---
title: llarp/win32/windivert.hpp

---

# llarp/win32/windivert.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::win32](Namespaces/namespacellarp_1_1win32.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::win32::WinDivert_API](Classes/classllarp_1_1win32_1_1WinDivert__API.md)**  |




## Source code

```cpp
#pragma once
#include <memory>
#include <string>
#include <windows.h>
#include <llarp/vpn/i_packet_io.hpp>

namespace llarp::win32
{
  struct WinDivertDLL;

  class WinDivert_API
  {
    std::shared_ptr<WinDivertDLL> m_Impl;

   public:
    WinDivert_API();

    std::string
    format_ip(uint32_t ip) const;

    std::shared_ptr<llarp::vpn::I_Packet_IO>
    make_intercepter(std::string filter_spec, std::function<void(void)> wakeup) const;
  };
}  // namespace llarp::win32
```


-------------------------------

Updated on 2022-09-10 at 18:17:15 +0000
